unit Main;

{ Main unit for the CAMEL language project. V0.00a
  Please modify it, by adding others procedures, functions...
  I actively develop this project and any help would be greatly appreciated.
  If you modify it, please send me the code to my personal adress: Colin.Laplace@Wanadoo.fr
  Please take a look to ReadMe.txt

  Thanks,
  Colin LAPLACE
  http://camel-project.home.ml.org/
  http://bloodshed-software.home.ml.org/
  Colin.Laplace@Earthcorp.com
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  LangValMessages,CompEd, StdCtrls, Compiler, RXSplit, Grids, Outline,
  ExtCtrls,CmpUtils,ObjLangF, Code, SpeedBar, Buttons,Decompiler,ShowProc,
  uObjVM, ObjVM, LangValue, VisualValue, LangProc, ProxyValue, FMXUtils,IniFiles;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    CompileBut: TButton;
    Memo1: TMemo;
    RxSplitter1: TRxSplitter;
    aCode: TCode;
    SpeedBar1: TSpeedBar;
    SpeedbarSection1: TSpeedbarSection;
    BitBtn1: TBitBtn;
    Memo2: TMemo;
    BitBtn2: TBitBtn;
    CaptionProc: TLangProc;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    SaveVM: TSaveDialog;
    RunProc: TLangProc;
    CreateDirProc: TLangProc;
    BitBtn3: TBitBtn;
    ShowProc: TLangProc;
    CopyFileProc: TLangProc;
    MoveFileProc: TLangProc;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    CreateFileProc: TLangProc;
    WriteToFileProc: TLangProc;
    BitBtn7: TBitBtn;
    InputQueryProc: TLangProc;
    procedure CompileButClick(Sender: TObject);
    procedure Compiler1Error(Sender: TObject; LineNo, TokenNo,
      ErrorType: Integer; const Token, Msg: string);
    procedure Compiler1TreeReady(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure CaptionProcExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure RunProcExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure CreateDirProcExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure BitBtn3Click(Sender: TObject);
    procedure ShowProcExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure CopyFileProcExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure MoveFileProcExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure BitBtn6Click(Sender: TObject);
    procedure CreateFileProcExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure WriteToIniProcExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure BitBtn7Click(Sender: TObject);
    procedure InputQueryProcExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure BitBtn5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation
uses InputQueryProc,VarLangValue, uRunTime, Unit1;
{$R *.DFM}

procedure TMainForm.CompileButClick(Sender: TObject);
begin
  if ObjLang.CompileTo(Memo1.Lines,aCode)
  then
    Caption:='Ok'
  else
    Caption:='Error';
end;

procedure TMainForm.Compiler1Error(Sender: TObject; LineNo, TokenNo,
  ErrorType: Integer; const Token, Msg: string);
begin
  MessageDlg(Format('Error %s %s',[Token,Msg]),mtInformation,[mbOk],0)
end;

procedure TMainForm.Compiler1TreeReady(Sender: TObject);
begin
//  TreeToOutline(Compiler1.Tree,Outline1);
end;

procedure TMainForm.Panel1Click(Sender: TObject);
begin
//  EditCompiler(Compiler1,nil);
end;

procedure TMainForm.BitBtn1Click(Sender: TObject);
begin
  With TObjLang.Create(nil) do
  begin
    try
    try
      CompileTo(Memo1.Lines,aCode); // Compile the code
      Caption:='Ok';
      Decompile(aCode,Memo2.Lines); // Write the Virtual Machine codes generated
     except
      On e:Exception do
      begin
        Caption:=e.Message;
      end;
    end;
    finally Free end;
  end;
end;

procedure TMainForm.BitBtn2Click(Sender: TObject);
begin
  RunTime.VM.Run(aCode); // Run the code after compilation
end;

procedure TMainForm.CaptionProcExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
         Var I:Integer;
              str:string;
              Res:TVarLangValue;
          begin
            str:='';
            for i:=0 to S.FrameCount-1 do
            begin
              str:=str+s.FrameValues[i].AsString;
            end;
            if s.FrameCount<>0 then Caption:=str;    // The form caption change: Example: Caption('The CAMEL language v0.00a');
            S.DropFrame;
            if MustReturn then
            begin
              Res:=TVarLangValue.Create(nil);
              Res.AsString:=Caption;
              S.Push(Res);
            end;
          end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    Memo1.Lines.LoadFromFile(OpenDialog.Filename); // Load Camel source code
  end;
end;

procedure TMainForm.RunProcExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
   Var I:Integer;
              str:string;
              Res:TVarLangValue;
          begin
            str:='';
            for i:=0 to S.FrameCount-1 do
            begin
              str:=str+s.FrameValues[i].AsString;
            end;
            if s.FrameCount<>0 then ExecuteFile(str,'',ExtractFilePath(str),SW_Show);
        // Run a file: Example: Run('c:\windows\notepad.exe');
            S.DropFrame;
            if MustReturn then
            begin
              Res:=TVarLangValue.Create(nil);
              Res.AsString:=Caption;
              S.Push(Res);
            end;
          end;

procedure TMainForm.CreateDirProcExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);

   Var I:Integer;
              str:string;
              Res:TVarLangValue;
          begin
            str:='';
            for i:=0 to S.FrameCount-1 do
            begin
              str:=str+s.FrameValues[i].AsString;
            end;
           if s.FrameCount<>0 then
           begin
           MakeDir(str);
    // Create a directory: Example: CreateDir('c:\Test');
           end;
            S.DropFrame;
            if MustReturn then
            begin
              Res:=TVarLangValue.Create(nil);
              Res.AsString:=Caption;
              S.Push(Res);
            end;
          end;


procedure TMainForm.BitBtn3Click(Sender: TObject);
begin
BitBtn1Click(Sender);
BitBtn2Click(Sender);
end;

procedure TMainForm.ShowProcExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
         Var I:Integer;
              str:string;
              Res:TVarLangValue;
          begin
            str:='';
            for i:=0 to S.FrameCount-1 do
            begin
              str:=str+s.FrameValues[i].AsString;
            end;
            S.DropFrame;
            if MustReturn then
            begin
              Res:=TVarLangValue.Create(nil);
              Res.AsBoolean:=true;
              S.Push(Res);
            end;
            MessageDlg(str,mtInformation,[mbOk],0);
       // Show a message: example: Show('This is a test');
          end;


procedure TMainForm.CopyFileProcExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
    Var SDest,sFrom:string;
              aResult:boolean;
              iDest,iFRom:integer;
              vDest,vFRom,vValue,vResult:ILangValue;
          begin
            SDest:='';
            sFrom:='';
            iFrom:=-1;
            iDest:=-1;
            case s.FrameCount of
              1:begin
                 iDest:=0;
                end;
              2:begin
                 iFrom:=0;
                 iDest:=1;
                end;
            end;
            if iDest<>-1 then
            begin
              sDest:=s.FrameValues[iDest].AsString;
            end;
            if iFrom<>-1 then
            begin
              SFrom:=s.FrameValues[iFrom].AsString;
            end;
            s.DropFrame;
            aResult:= true;
              CopyFile(SFrom,sDest);
          // Copy a file: example: CopyFile('c:\aaa.txt','c:\windows');
            if MustReturn then
            begin
              vResult:=TVarLangValue.Create(nil);
              vResult.AsBoolean:=aResult;
              s.Push(vResult);
            end;
          end;

procedure TMainForm.MoveFileProcExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
 Var SDest,sFrom:string;
              aResult:boolean;
              iDest,iFRom:integer;
              vDest,vFRom,vValue,vResult:ILangValue;
          begin
            SDest:='';
            sFrom:='';
            iFrom:=-1;
            iDest:=-1;
            case s.FrameCount of
              1:begin
                 iDest:=0;
                end;
              2:begin
                 iFrom:=0;
                 iDest:=1;
                end;
            end;
            if iDest<>-1 then
            begin
              sDest:=s.FrameValues[iDest].AsString;
            end;
            if iFrom<>-1 then
            begin
              SFrom:=s.FrameValues[iFrom].AsString;
            end;
            s.DropFrame;
            aResult:= true;
              MoveFile(SFrom,sDest);
        // Move a file: example: MoveFile('c:\readme.txt','c:\Myfiles');

            if MustReturn then
            begin
              vResult:=TVarLangValue.Create(nil);
              vResult.AsBoolean:=aResult;
              s.Push(vResult);
            end;
          end;

procedure TMainForm.BitBtn6Click(Sender: TObject);
begin
if SaveVM.Execute then
Memo2.Lines.SaveToFile(SaveVM.FileName);     // Save VM codes
end;

procedure TMainForm.CreateFileProcExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
  Var I, FileHandler:Integer;
              str:string;
              Res:TVarLangValue;
          begin
            str:='';
            for i:=0 to S.FrameCount-1 do
            begin
              str:=str+s.FrameValues[i].AsString;
            end;
            if s.FrameCount<>0 then
            begin
        FileHandler:=  FileCreate(str);
            FileClose(FileHandler);
            end;
        // Create a file: Example: CreateFile('c:\readme.txt');
            S.DropFrame;
            if MustReturn then
            begin
              Res:=TVarLangValue.Create(nil);
              Res.AsString:=Caption;
              S.Push(Res);
            end;
          end;

procedure TMainForm.WriteToIniProcExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
 Var sIniName,sSection,sName,SValue:string;
              aResult:boolean;
              iIniName,iSection,iName,iValue:integer;
              vIniName,vSection,vName,vValueRef,vValue,vResult:ILangValue;
     IniFile: TIniFile;
          begin
            sIniName:='';
            sSection:='';
            sName:='';
            sValue:='';
            vValueRef:=nil;
            iIniName:=-1;
            iSection:=-1;
            iName:=-1;
            iValue:=-1;
            case s.FrameCount of
              1:begin
                  iValue:=0;
                end;
              2:begin
                  iName:=0;
                  iValue:=1;
                end;
              3:begin
                  iSection:=0;
                  iName:=1;
                  iValue:=2;
                end;
              4:begin
                  iIniName:=0;
                  iSection:=1;
                  iName:=2;
                  iValue:=3;
                end;
            end;
            if iValue<>-1 then
            begin
              sValue:=s.FrameValues[iValue].AsString;
            end;
            if iName<>-1 then
            begin
              sName:=s.FrameValues[iName].AsString;
            end;
            if iSection<>-1 then
            begin
              sSection:=s.FrameValues[iSection].AsString;
            end;
            if iIniName<>-1 then
            begin
              sIniName:=s.FrameValues[iIniName].AsString;
            end;
            s.DropFrame;
            IniFile := TIniFile.Create(sIniName);
            aResult:= true;
            IniFile.WriteString(sSection,sName,sValue);

            if MustReturn then
            begin
              vResult:=TVarLangValue.Create(nil);
              vResult.AsBoolean:=aResult;
              s.Push(vResult);
            end;
          end;


procedure TMainForm.BitBtn7Click(Sender: TObject);
begin
Application.Terminate;
end;

procedure TMainForm.InputQueryProcExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
Var sCaption,sPrompt,sValue:string;
              aResult:boolean;
              iCaption,iPrompt,iValue:integer;
              vCaption,vPrompt,vValueRef,vValue,vResult:ILangValue;
          begin
            sCaption:='';
            sPrompt:='';
            sValue:='';
            vValueRef:=nil;
            iCaption:=-1;
            iPrompt:=-1;
            iValue:=-1;
            case s.FrameCount of
              1:begin
                  iValue:=0;
                end;
              2:begin
                  iPrompt:=0;
                  iValue:=1;
                end;
              3:begin
                  iCaption:=0;
                  iPrompt:=1;
                  iValue:=2;
                end;
            end;
            if iValue<>-1 then
            begin
              vValueRef:=s.FrameValues[iValue].CreateEqu;
              vValue:=vValueRef.GetValue;
              sValue:=vValue.AsString;
              vValue.Free;
            end;
            if iPrompt<>-1 then
            begin
              sPrompt:=s.FrameValues[iPrompt].AsString;
            end;
            if iCaption<>-1 then
            begin
              sCaption:=s.FrameValues[iCaption].AsString;
            end;
            s.DropFrame;
            aResult:=InputQuery(sCaption,sPrompt,sValue);
            if iValue<>-1 then
            begin
              vValue:=TVarLangValue.Create(nil);
              vValue.AsString:=sValue;
              vValueRef.SetValue(vValue);
              vValueRef.Free;
            end;
            if MustReturn then
            begin
              vResult:=TVarLangValue.Create(nil);
              vResult.AsBoolean:=aResult;
              s.Push(vResult);
            end;
          end;

procedure TMainForm.BitBtn5Click(Sender: TObject);
begin
if SaveDialog.Execute then
Memo1.Lines.SaveToFile(SaveDialog.FileName);
end;

end.
